#include <bits/stdc++.h>
using namespace std;
int prodbonacci(int a, int b)
{
int z,br=0,d=1;
z=a*b;
int g=z;

if(z==0) br+=1;

while(z!=0){
    z/=10;
    br++;

}

for(int i=0;i<br;i++)
{
   if(g%10>0)
   {
   z=(g%10-1)*d+z;
   }
   else z=(9)*d+z;
   d=d*10;
   g/=10;
}

return z%1000;

}
int main(){
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int a,b,n,c;
    cin>>n;
    cin>>a>>b;
    for(int i=0;i<n/2+1;i++)
    {
        c=b;
    b=prodbonacci(a,b);
    a=c;
   // cout<<a<<" "<<b<<endl;
    }
    cout<<b<<endl;


    return 0;
}


